<!DOCTYPE html>
<html lang="en">
<head>
	<meta name="viewport" content="width=device-width, height=device-height, initial-scale=1.0">
	<meta charset="UTF-8">
	<title>Document</title>
</head>
<body  style="width: 100vw; height: 100vh; max-width: 100%; max-height: 100%; margin: 0px; padding: 0px; overflow: hidden">
	<script
			  src="https://code.jquery.com/jquery-3.3.1.min.js"
			  integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8="
			  crossorigin="anonymous"></script>



	<canvas id="canvas" style="margin: 0px;"></canvas>







	<script type="text/javascript">
		var canvas = document.getElementById("canvas");
		var w = canvas.width  = window.innerWidth;
		var h = canvas.height = window.innerHeight;
		var ctx = canvas.getContext('2d');


		var ballSpeed = 4;
		var barSpeed = 3;
		var size1 = 120;
		var size2 = 120;

		var updates = 5;

		var ballFinalMoveSpeed = 1;

		var bar1 = { 'x' : 15, 'y': h/2 - size1/2, 'h': size1, 'w': 20, 'speed': barSpeed};
		var bar2 = { 'x' : w - 35, 'y': h/2 - size2/2, 'h': size2, 'w': 20, 'speed': barSpeed};
		var ball = { 'x' : w/2 - 7, 'y': h/2 - 7, 'r': 15, 'move': {'speed': ballSpeed, "ang": 0}};


		function resetBars(){
			bar1 = { 'x' : 15, 'y': h/2 - size1/2, 'h': size1, 'w': 20, 'speed': barSpeed};
			bar2 = { 'x' : w - 35, 'y': h/2 - size2/2, 'h': size2, 'w': 20, 'speed': barSpeed};


		}

		var rightPoints = 0;
		var leftPoints = 0;

		var keys = {
			'W': false,
			'S': false,
			'r_up': false,
			'r_down': false
		}


		printAll();

		var started = false;


		ctx.fillStyle = 'white';
		ctx.font = "50px Arial";
		ctx.fillText("Pressione qualquer tecla para iniciar.", w/2 - 0.25*w, h*0.1);



		$(document).bind('keydown', function(){
			if(!started){
				started = true;
				startLevel();








			}
		});


		function startLevel(){

			setInterval(update, updates);

			$(document).bind('keydown', clicked);
			$(document).bind('keyup', released);

			startBall();


		}

		function update(){


		

			updateMoves();



			updateBall();

			
			printAll();

		}

		function updateBall(){

			fixAng();



			for(var x = 0; x < ball.move.speed; x++){

				moveBall();
			}

			

		}

		function moveBall(){
			var inside = false;


			ball.x = ball.x + ballFinalMoveSpeed * Math.cos(deg(ball.move.ang));
			ball.y = ball.y + ballFinalMoveSpeed * Math.sin(deg(ball.move.ang));

			if(ball.x - ball.r <= 0){
				//updateAng('left');
				rightPoints++;
				startBall();
			}
			if(ball.y + ball.r >= h){
				updateAng('bottom');
			}
			if(ball.y - ball.r <= 0){
				updateAng('top');
			}

			if(Math.round(ball.x + ball.r) == Math.round(bar2.x)){
				if(ball.y >= bar2.y - 5 && ball.y <= bar2.y + bar2.h + 5){
					if(!inside){
						inside  = true;
						updateAng('right');	
					}
				}

			} else {
				if(inside) inside = false;
				if(ball.x + ball.r >= w){
					//updateAng('right');
					leftPoints++;
					startBall();
				}


			}
			if(Math.round(ball.x - ball.r) == Math.round(bar1.x + bar1.w)){
				if(ball.y >= bar1.y - 5 && ball.y <= bar1.y + bar1.h + 5){
					if(!inside){
						inside  = true;
						updateAng('left');	
					}
				}
			} else {
				if(inside) inside = false;
				if(ball.x - ball.r <= 0){
					//updateAng('left');
					rightPoints++;
					startBall();
				}

			}


		}


		

		function updateAng(wall){

			switch(wall){
				case 'top':
					ball.move.ang = 360 - ball.move.ang;
				break;
				case 'right':
					ball.move.ang = 540 - ball.move.ang;
				break;
				case 'left':
					ball.move.ang = 540 - ball.move.ang;
				break;
				case 'bottom':
					ball.move.ang = 360 - ball.move.ang;
				break;

			}

			fixAng();

		}

		function fixAng(){
			if(ball.move.ang >= 0){
				ball.move.ang = ball.move.ang % 360;
			} else {

				ball.move.ang = -1 * ball.move.ang;
				ball.move.ang = ball.move.ang % 360;
				ball.move.ang = 360 - ball.move.ang;
			}


		}




		function deg (angle) {
			return angle / (180 / Math.PI);
		}



		function clicked(e){
			var code = e.keyCode || e.which;


			switch(code){
				case 38:
					keys['r_up'] = true;
				break;
				case 40:
					keys['r_down'] = true;
				break;
				default:
					keys[String.fromCharCode(code)] = true;
				break;
			}


		}






		function released(e){
			var code = e.keyCode || e.which;


			switch(code){
				case 38:
					keys['r_up'] = false;
				break;
				case 40:
					keys['r_down'] = false;
				break;
				default:
					keys[String.fromCharCode(code)] = false;
				break;
			}


		}











		function updateMoves(){
			if(keys['W']){
				move(bar1, 'up');
			}
			if(keys['S']){
				move(bar1, 'down');
			}
			if(keys['r_up']){
				move(bar2, 'up');
			}
			if(keys['r_down']){
				move(bar2, 'down');
			}

		}

		function move(obj, direc){
			switch(direc){

				case 'down':
					if(obj.y + obj.h < h){
						obj.y += obj.speed;
					}
				break;
				case 'up':
					if(obj.y > 0){
						obj.y -= obj.speed;
					}
				break;

			}
		}







		var time = 0;

		var waiting = true;

		function wait(){
			printAll();
			waiting = true;
			if(time > 0){
				printWait();
				time--;
				setTimeout(wait, 1000);
			} else {
				waiting = false;
				startBall(true);
			}



		}


		function printWait(){

				ctx.fillStyle = 'white';
				ctx.font = "50px Arial";
				ctx.fillText(time+1, w/2 - 0.012*w, h*0.1);
		}

		function startBall(now){

			if(now){

				ball = { 'x' : w/2 - 7, 'y': h/2 - 7, 'r': 15, 'move': {'speed': ballSpeed, "ang": 0}};







				var ang = 40 - Math.random() * 80;
				var side = Math.round(Math.random() * 2 - 1);
				if(side) ang += 180;


				ball.move.ang = ang;

				fixAng();
				

			} else {

				ball = { 'x' : w/2 - 7, 'y': h/2 - 7, 'r': 15, 'move': {'speed': 0, "ang": 0}};


				time = 3;
				wait();

			}



		}


		function printAll(){

			ctx.fillStyle = 'black';
			ctx.fillRect(0, 0, w, h);
	
 			
			ctx.fillStyle = 'green';
			ctx.fillRect(bar1.x, bar1.y, bar1.w, bar1.h);
			ctx.font = "50px Arial";
			ctx.fillText(leftPoints,w/2 - w*0.12, h * 0.3);


			
			
			ctx.fillStyle = 'blue';
			ctx.fillRect(bar2.x, bar2.y, bar2.w, bar2.h);
			ctx.font = "50px Arial";
			ctx.fillText(rightPoints,w/2 + w/10, h * 0.3); 



			ctx.fillStyle = 'white';
			ctx.beginPath();
			ctx.arc(ball.x,ball.y,ball.r,0,2*Math.PI);
			ctx.fill();

 			if(waiting){
 				printWait();
 			}

		}


	</script>
</body>
</html>